﻿if not HCoold then return false end
local L = HCoold:GetLocale()
local spells = {} -- spells that we can track by system
local spec_spells = {} -- spells that are uniq for each spec of class

do -- generate spells list
	do -- generate spells
		local type1 = {------ type == 1  аура на -дамаг +хил
			{ -- аура благочестия
				spellID = 31821,
				class = "PALADIN", 
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 0 },
				CD = 180,
				cast_time = 6,
				quality = 1,
			},
			{ -- купол
				spellID = 62618,
				class = "PRIEST", 
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 1 },
				CD = 120,
				cast_time = 10,
				quality = 1,
			},
			{ -- тотем шаман  !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 98008,
				class = "SHAMAN", 
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 6,
				quality = 3,
			},
			{ -- Ободряющий клич
				spellID = 97462,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "WARRIOR",
				cast_time = 10,
				quality = 1,
			},
			{ -- монах дзен-медитация (-90% урона + 5 кастов на монаха)
				spellID = 115176,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				cast_time = 8,
				class = "MONK",
				quality = 1,
			},
			{ -- монах отведение ударов (-20% урона рейду)
				spellID = 115213,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 180,
				cast_time = 6,
				class = "MONK",
				quality = 1,
			},
		}
		local type2 = {------ type == 2 аое хил
			{ -- божественный гимн holy
				spellID = 64843,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 2 },
				class = "PRIEST",
				quality = 3,
				cast_time = 8,
			},
			{ -- колодец света
				spellID = 724,
				succ = "SPELL_SUMMON",
				CD = 180,
				specs = { 2 },
				class = "PRIEST",
				quality = 3,
			},
			{ -- спокойствие дру feral
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				specs = { 2, 3, },
				class = "DRUID",
				quality = 1,
				cast_time = 8,
			},
			{ -- спокойствие дру balance
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				specs = { 1 },
				class = "DRUID",
				quality = 2,
				cast_time = 8,
			},
			{ -- спокойствие дру restor
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 4 },
				class = "DRUID",
				quality = 3,
				cast_time = 8,
			},
			{ -- монах Восстановление сил (разовый хил хил всему рейду)
				spellID = 115310,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 180,
				class = "MONK",
				quality = 1,
			},
		}
		local type3 = {------ type == 3 на ману
			{ -- гимн надежды
				spellID = 64901, -- 64904 - проки на ману
				succ = "SPELL_CAST_SUCCESS",
				CD = 360,
				specs = { 0 },
				class = "PRIEST",
				quality = 3, 
				cast_time = 8,
			},
			{ -- мана тайд !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 16190,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 3 },
				class = "SHAMAN",
				quality = 3, 
				cast_time = 16,
			},
			{ -- друид озарение
				spellID = 29166,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "DRUID",
				quality = 1,
			},
		}
		local type4 = {------ type == 4  личный кд
			{ -- Ярость шамана (энх)
				spellID = 30823,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 60,
				class = "SHAMAN",
				quality = 1,
				cast_time = 15,
			},
			{ -- бабл прист
				spellID = 47585,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 120,
				class = "PRIEST",
				cast_time = 6,
				quality = 1,
			},
			{ -- Ни шагу назад
				spellID = 12975,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 180,
				class = "WARRIOR",
				cast_time = 20,
				quality = 1,
			},
			{ -- Бой на смерть (парирование 100%) вар
				spellID = 118038,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1, 2 },
				CD = 120,
				cast_time = 8,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Глухая оборона
				spellID = 871,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 300,
				class = "WARRIOR",
				cast_time = 12,
				quality = 1,
			},
			{ -- плащ теней
				spellID = 31224,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "ROGUE",
				cast_time = 5,
				quality = 1,
			},
			{ -- ускользание
				spellID = 5277,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "ROGUE",
				cast_time = 15,
				quality = 1,
			},
			{ -- маг леденая глыба
				spellID = 45438,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 300,
				class = "MAGE",
				cast_time = 10,
				quality = 1,
			},
			{ -- друид дубовая кожа
				spellID = 22812,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1, 2, 3, },
				CD = 60,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- друид дубовая кожа
				spellID = 22812,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 4 },
				CD = 45,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- друид мощь урсока
				spellID = 106922,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "DRUID",
				cast_time = 20,
				quality = 1,
			},
			{ -- друид инстинкты выживания (шв)
				spellID = 61336,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2, 3, },
				CD = 180,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- варлок твердая решимость (шв)
				spellID = 104773,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "WARLOCK",
				cast_time = 8,
				quality = 1,
			},
			{ -- паладин ревностный защитник
				spellID = 31850,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 180,
				cast_time = 10,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин бабл
				spellID = 642,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 300,
				cast_time = 8,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин шв
				spellID = 86659,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 120,
				cast_time = 12,
				class = "PALADIN",
				quality = 1,
			},
			{ -- монах закон кармы (мили дамаг в него перевод в цель)
				spellID = 122470,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 90,
				cast_time = 10,
				class = "MONK",
				quality = 1,
			},
			{ -- хант сдерживание
				spellID = 19263,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				cast_time = 5,
				class = "HUNTER",
				quality = 1,
			},
			{ -- монах укрепляющий отвар (барскин+ласт стенд)
				spellID = 115203,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				cast_time = 20,
				cast_time = 4,
				class = "MONK",
				quality = 1,
			},
			{ -- дк мини шв
				spellID = 48792,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				cast_time = 12,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк софт кд -20% дамаги
				spellID = 49222,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 60,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк кровь вампира (+хил/хп)
				spellID = 55233,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 60,
				cast_time = 10,
				class = "DEATHKNIGHT",
				quality = 1,
			},
		}
		local type5 = {------ type == 5  точечный кд --------------- !aproved!!aproved!!aproved!!aproved!!aproved!
			{ -- крылья 
				spellID = 47788,
				class = "PRIEST",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 3,
				cast_time = 10,
			},
			{ -- пска 
				spellID = 33206,
				class = "PRIEST",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 3,
				cast_time = 8,
			},
			{ -- друид железная кора (-дамаг рестор)
				spellID = 102342,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 4 },
				CD = 120,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- сакрифайс от не прота 
				spellID = 6940,
				class = "PALADIN",
				specs = { 1, 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				cast_time = 12,
			},
			{ -- сакрифайс от прота 
				spellID = 6940,
				class = "PALADIN",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 2,
				cast_time = 12,
			},
			{ -- паладин боп
				spellID = 1022,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 300,
				cast_time = 10,
				class = "PALADIN",
				quality = 1,
			},
			{ -- монах Исцеляющий кокон (директ кд на -х дамага и +хил с хотов)
				spellID = 116849,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 120,
				cast_time = 12,
				class = "MONK",
				quality = 1,
			},
		}
		local type6 = {------ type == 6  кд на +дамаг 
			{ -- Тотем элема огня !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 2894,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 60,
			},
			{ -- Тотем элементаля земли !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 2062,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 60,
			},
			{ -- Тотем порыва бури !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 120668,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 10,
			},
			{ -- войско мертвых дк
				spellID = 42650,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 600,
				cast_time = 44,
			},
			{ -- Сокрушительный бросок	
				spellID = 64382,
				CD = 300,
				specs = { 0 },
				succ = {"SPELL_CAST_SUCCESS", "SPELL_DAMAGE", "SPELL_MISSED" },
				class = "WARRIOR",
				quality = 2,
				cast_time = 10,
			},
			{ -- шаман бл  !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 2825,  -- за аликов 32182
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "SHAMAN",
				quality = 3,
				cast_time = 40,
				trigger = { 32182, },
			},
			{ -- маг бл
				spellID = 80353,
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "MAGE",
				quality = 3,
				cast_time = 40,
			},
			{ -- варлок призыв инфернала
				spellID = 1122,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 600,
				trigger = { 18540, },
				class = "WARLOCK",
				cast_time = 60,
				quality = 1,
			},
			{ -- дк нечестивое бешенство (бафф от нечестивости)
				spellID = 49016,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 180,
				cast_time = 30,
				class = "DEATHKNIGHT",
				quality = 1,
			},
--[[
			{ -- хантер бл ??????????????????????
				spellID = 90355,
				CD = 360,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "HUNTER",
				quality = 3,
				cast_time = 40,
			},
--]]
		}
		local type7 = {------ type == 7  возрождения -- SPELL_RESURRECT  ????
			{ -- возрождение Дру 
				spellID = 20484,
				succ = "SPELL_CAST_START", -- SPELL_RESURRECT
				specs = { 0 },
				CD = 600,
				class = "DRUID",
				quality = 3,
			},
			{ -- возрождение ДК 
				spellID = 61999,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 600,
				class = "DEATHKNIGHT",
				quality = 2,
			},
			--[[ -- unable to track without oRA
			{ -- перерождение шам ???????????????????
				spellID = 20608,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 1800,
				class = "SHAMAN",
				quality = 1,
			},
			--]]
			{ -- воскрешение камнем души
				spellID = 20707,
				succ = "SPELL_CAST_START", 
				specs = { 0 },
				CD = 900,
				class = "WARLOCK",
				quality = 1,
			},
		}
		local type8 = {------ type == 8  прочее
			----------------- Шаманы
			{ -- благосклонность предков (касты на ходу у шамана)
				spellID = 79206,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "SHAMAN",
				cast_time = 15,
				quality = 1,
			},
			{ -- очищение духа (не рестор шаман)
				spellID = 51886,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1, 2 },
				CD = 8,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- очищение духа (рестор шаман)
				spellID = 77130,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 8,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- пронизывающий ветер (сбитие каста шаман)
				spellID = 57994,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 12,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- сглаз (лягушка шаман)
				spellID = 51514,
				succ = {"SPELL_AURA_REFRESH", "SPELL_AURA_APPLIED", },
				specs = { 0 },
				CD = 45,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- тотем трепета шаман
				spellID = 8143,
				succ =  "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "SHAMAN",
				cast_time = 6,
				quality = 1,
			},
			{ -- Тотем заземления !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 8177,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 25,
				quality = 1,
				cast_time = 15,
			},
			{ -- гром и молния элем
				spellID = 51490,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 45,
				class = "SHAMAN",
				quality = 1,
			},
			
			----------------- Присты
			{ -- духовое рвение (тянулка прист)
				spellID = 73325,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 90,
				class = "PRIEST",
				quality = 1,
			},
			{ -- защита от страха
				spellID = 6346,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "PRIEST",
				quality = 1,
			},
			{ -- исчадие тьмы
				spellID = 34433,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "PRIEST",
				quality = 1,
				cast_time = 12,
			},
			{ -- масс диспел
				spellID = 32375,
				succ = "SPELL_CAST_START", 
				specs = { 0 },
				CD = 15,
				class = "PRIEST",
				quality = 1,
			},
			{ -- диспел
				spellID = 527,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1, 2 },
				CD = 8,
				class = "PRIEST",
				quality = 1,
			},
			{ -- уход в тень
				spellID = 586,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "PRIEST",
				cast_time = 10,
				quality = 1,
			},
			{ -- архангел диск
				spellID = 81700,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 30,
				class = "PRIEST",
				cast_time = 18,
				quality = 1,
			},
			{ -- внутреннее сосредоточение
				spellID = 89485,
				succ = "SPELL_AURA_REMOVED", 
				specs = { 1 },
				CD = 45,
				class = "PRIEST",
				quality = 1,
			},
			{ -- щит души диск
				spellID = 109964,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 60,
				class = "PRIEST",
				cast_time = 15,
				quality = 1,
			},
			{ -- объятие вампира
				spellID = 15286,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 180,
				class = "PRIEST",
				cast_time = 15,
				quality = 1,
			},
			
			----------------- Вары
			{ -- Героический прыжок
				spellID = 52174,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 45,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Зуботычина
				spellID = 6552,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 15,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Обезоруживание
				spellID = 676,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Отражение заклинаний
				spellID = 23920,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 25,
				class = "WARRIOR",
				cast_time = 5,
				quality = 1,
			},
			{ -- Рывок
				spellID = 100,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 20,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Смертельное спокойствие
				spellID = 85730,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Деморализующий крик
				spellID = 1160,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 60,
				class = "WARRIOR",
				cast_time = 10,
				quality = 1,
			},
			
			----------------- Роги
			{ -- долой оружие
				spellID = 51722,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "ROGUE",
				cast_time = 10,
				quality = 1,
			},
			{ -- исчезновение
				spellID = 1856,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маленькие хитрости 
				spellID = 57934,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "ROGUE",
				cast_time = 6,
				quality = 1,
			},
			{ -- пинок
				spellID = 1766,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 15,
				class = "ROGUE",
				quality = 1,
			},
			{ -- спринт
				spellID = 2983,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "ROGUE",
				cast_time = 8,
				quality = 1,
			},
		
			----------------- Маги
			{ -- маг антимагия (сало)
				spellID = 2139,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 24,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг глубокая заморозка
				spellID = 44572,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг зеркальное изображение
				spellID = 55342,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "MAGE",
				cast_time = 30,
				quality = 1,
			},
			{ -- маг невидимость
				spellID = 66,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 300,
				class = "MAGE",
				cast_time = 23,
				quality = 1,
			},
			{ -- маг прилив сил
				spellID = 12051,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг скачок
				spellID = 1953,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 15,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг диспел
				spellID = 475,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 8,
				class = "MAGE",
				quality = 1,
			},
			--[[
			{ -- маг столик
				spellID = 43987,
				succ = "SPELL_CAST_START", 
				specs = { 0 },
				CD = 60,
				class = "MAGE",
				quality = 1,
			},--]]
			{ -- маг дыхание дракона
				spellID = 31661,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 20,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг призыв пета фростом
				spellID = 31687,
				succ = "SPELL_SUMMON", 
				specs = { 3 },
				CD = 60,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг леденая сфера
				spellID = 84714,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 60,
				cast_time = 10,
				class = "MAGE",
				quality = 1,
			},
			
			----------------- Друид
			{ -- друид порыв
				spellID = 1850,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- друид хватка природы
				spellID = 16689,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "DRUID",
				quality = 1,
			},
			{ -- друид тревожный рев
				spellID = 77764,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "DRUID",
				trigger = { 106898, },
				cast_time = 8,
				quality = 1,
			},
			{ -- друид звездопад баланс
				spellID = 48505,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 90,
				class = "DRUID",
				quality = 1,
			},
			{ -- друид снятие порчи (не рестор)
				spellID = 2782,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1, 2, 3, },
				CD = 8,
				class = "DRUID",
				quality = 1,
			},
			{ -- друид столп солнечного света (сбитие каста)
				spellID = 78675,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "DRUID",
				cast_time = 10,
				quality = 1,
			},
			{ -- друид берсерк (котэ+мэдвед)
				spellID = 106951,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2, 3, },
				CD = 180,
				trigger = { 50334, },
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- друид ферал сбитие каста
				spellID = 80965,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2, 3, },
				CD = 15,
				class = "DRUID",
				trigger = { 80964, },
				quality = 1,
			},
			{ -- друид танк иступление
				spellID = 5229,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 60,
				class = "DRUID",
				quality = 1,
			},
			{ -- друид диспел рестор
				spellID = 88423,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 4 },
				CD = 8,
				class = "DRUID",
				quality = 1,
			},
			
			----------------- Варлок
			{ -- варлок телепортация
				spellID = 48020,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок занавес сумерек
				spellID = 6229,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок раскол души
				spellID = 29858,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок ритуал призыва
				spellID = 698,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок создание источника душ
				spellID = 29893,
				succ = "SPELL_CREATE", 
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок дестро воскрешение пета инста
				spellID = 120451,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 60,
				class = "WARLOCK",
				quality = 1,
			},
			
			----------------- Паладин
			{ -- паладин божественная защита (-40% магии)
				spellID = 498,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				cast_time = 10,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин божественно покровительство (20% хасты хпалу)
				spellID = 31842,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 180,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин лох
				spellID = 633,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 600,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин фридом
				spellID = 1044,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 25,
				cast_time = 6,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин сальва
				spellID = 1038,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин дефки холик
				spellID = 86669,
				succ = "SPELL_SUMMON", 
				specs = { 1 },
				CD = 300,
				cast_time = 30,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин стан
				spellID = 853,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин диспел
				spellID = 4987,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 8,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин клятва
				spellID = 54428,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 120,
				cast_time = 9,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин укор (сбитие каста)
				spellID = 96231,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 15,
				class = "PALADIN",
				quality = 1,
			},
		
			----------------- хантер
			{ -- хант замораживающая ловушка
				spellID = 1499,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1, 2 },
				CD = 30,
				trigger = { 82941, 13809, 60192 },
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант замораживающая ловушка сурв
				spellID = 1499,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 24,
				trigger = { 82941, 13809, 60192 },
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант осветилеьный выстрел
				spellID = 1543,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 20,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант отрыв
				spellID = 781,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 25,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант перенаправление
				spellID = 34477,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант приказ хозяина (фридом себе)
				spellID = 53271,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 45,
				cast_time = 4,
				class = "HUNTER",
				quality = 1,
			},
		
			------------------ монах
			{ -- монах дизарм :::::::::-------------------------????????
				spellID = 117368,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "MONK",
				quality = 1,
			},
			{ -- монах диспел
				spellID = 115450,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 8,
				class = "MONK",
				quality = 1,
			},
			{ -- монах рука-копье (сбитие каста)
				spellID = 116705,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 15,
				class = "MONK",
				quality = 1,
			},
			{ -- монах удар летящего змея
				spellID = 101545,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 25,
				class = "MONK",
				quality = 1,
			},
			
			------------------ дк
			{ -- дк антимагический панцирь
				spellID = 48707,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 45,
				cast_time = 5,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк сбитие каста
				spellID = 47528,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 15,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк хваталка
				spellID = 49576,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 25,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк призыв горгульи
				spellID = 49206,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 180,
				cast_time = 30,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			
		}
		local type9 = {--  type == 9  пвп кулдауны на контроль
			{ -- ментальный крик прист фир
				spellID = 8122,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "PRIEST",
				quality = 1,
			},
			{ -- стан прист
				spellID = 64044,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 45,
				class = "PRIEST",
				quality = 1,
			},
			{ -- сало прист
				spellID = 15487,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 45,
				class = "PRIEST",
				quality = 1,
				cast_time = 5,
			},
			{ -- Устрашающий крик (фир вара)
				spellID = 5246,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 60,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- дымовая шашка
				spellID = 76577,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "ROGUE",
				cast_time = 5,
				quality = 1,
			},
			{ -- ослепление
				spellID = 2094,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маг возгорание
				spellID = 11129,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 45,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг кольцо льда
				spellID = 122,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 25,
				class = "MAGE",
				quality = 1,
			},
			{ -- друид танк стан
				spellID = 102795,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 60,
				class = "DRUID",
				quality = 1,
			},
			{ -- хант дизориентирующий выстрел
				spellID = 19503,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант стан петом бм
				spellID = 19577,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 60,
				class = "HUNTER",
				quality = 1,
			},
			{ -- дк сало
				spellID = 47476,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 120,
				class = "DEATHKNIGHT",
				quality = 1,
			},
		}
		local type10 = {-- type == 10 кулдауны личные на +дамаг
			{ -- Дух дикого волка энх
				spellID = 51533,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 120,
				cast_time = 15,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- Ярость берсерка
				spellID = 18499,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 30,
				class = "WARRIOR",
				cast_time = 6,
				quality = 1,
			},
			{ -- Безрассудство
				spellID = 1719,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 300,
				class = "WARRIOR",
				cast_time = 12,
				quality = 1,
			},
			{ -- Вендетта
				spellID = 79140,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 120,
				class = "ROGUE",
				cast_time = 20,
				quality = 1,
			},
			{ -- Выброс адреналина
				spellID = 13750,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 180,
				class = "ROGUE",
				cast_time = 15,
				quality = 1,
			},
			{ -- Череда убийств
				spellID = 51690,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 120,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маг мощь тайной магии
				spellID = 12042,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 90,
				class = "MAGE",
				cast_time = 15,
				quality = 1,
			},
			{ -- маг стылая кровь фрост
				spellID = 12472,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				cast_time = 20,
				class = "MAGE",
				quality = 1,
			},
			{ -- друид парад планет (+dmg)
				spellID = 112071,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 180,
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- варлок афли +30% хасты
				spellID = 113860,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 120,
				cast_time = 20,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок демон +искусность
				spellID = 113861,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 120,
				cast_time = 20,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- паладин дефки ретрик
				spellID = 86698,
				succ = "SPELL_SUMMON", 
				specs = { 3 },
				CD = 300,
				cast_time = 30,
				class = "PALADIN",
				quality = 1,
			},
			{ -- варлок дестро +крит
				spellID = 113858,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 3 },
				CD = 120,
				cast_time = 20,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- паладин крылья
				spellID = 31884,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- хант быстрая стрельба
				spellID = 3045,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 180,
				cast_time = 15,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант готовность
				spellID = 23989,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 300,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант бм+дамаг
				spellID = 19574,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 1 },
				CD = 60,
				cast_time = 10,
				class = "HUNTER",
				quality = 1,
			},
			{ -- дк Ледяной столп (+сила фросту)
				spellID = 51271,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 2 },
				CD = 60,
				cast_time = 20,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			
		}
		local type11 = { -- type == 11 просто рандомный бред
		}
		local shok = { -- для отладки Шок небес
			spellID = 25914, -- ID спелла
			class = "PALADIN", -- класс, которому принадлежит спелл
			CD = 6, -- кулдаун в секундах у спела
			specs = { 1 },
			succ = "SPELL_HEAL", -- тип ивента, который означает удачное применение 1287
			type = 1,  --[[ тип спелла: 
					1 - аура на -дамаг (купол, мастер аур и тд) 
					2 - аое хил (гимн пристов, транквил) 
					3 - на ману (иннеры, гимн на ману, мана тайд) 
					4 - личный кд (айс блок, шв, бабл, отражение) 
					5 - точечный кд (пс, крылья, придание сил)
					6 - кд на +дамаг (варовский -армор, бл)
					7 - возрождения (друид, шаман, дк, лок)
					8 - прочие кд
				]]
			trigger = { 19750, }, -- дополнительные ид с которых триггерится ивент
			cast_time = 5, -- время действия спелла
			quality = 3, -- качество спелла при сортировке 1/nil - плохое 2 - хорошее 3 - лучшее
		}

		for _, i in next, type1 do i.type = 1; table.insert(spells,i) end
		for _, i in next, type2 do i.type = 2; table.insert(spells,i) end
		for _, i in next, type3 do i.type = 3; table.insert(spells,i) end
		for _, i in next, type4 do i.type = 4; table.insert(spells,i) end
		for _, i in next, type5 do i.type = 5; table.insert(spells,i) end
		for _, i in next, type6 do i.type = 6; table.insert(spells,i) end
		for _, i in next, type7 do i.type = 7; table.insert(spells,i) end
		for _, i in next, type8 do i.type = 8; table.insert(spells,i) end
		for _, i in next, type9 do i.type = 9; table.insert(spells,i) end
		for _, i in next, type10 do i.type = 10; table.insert(spells,i) end
		if HCoold.debug then table.insert(spells,shok) end
	end

	do -- generate spec_spells
		table.insert(spec_spells, { -- паладин 1 holy 2 prot 3 retri
			class = "PALADIN",
			specs = {
				[1] = { -- holy
					{ id = 82326, }, -- божественный свет
					{ id = 31842, }, -- божественное покровительство
					{ id = 86273, }, -- озаряющее исцеление
					{ id = 86669, }, -- защитник древних королей
					{ id = 2812, }, -- обличение
					{ id = 54149, }, -- прилив света
					{ id = 85222, }, -- свет зари
					{ id = 635, }, -- свет небес
					{ id = 54428, }, -- святая клятва
					{ id = 82327, }, -- святое сияние
					{ id = 88819, }, -- рассвет ?
					{ id = 53563, }, -- частица
					{ id = 25914, }, -- шок небес
				},
				[2] = { -- prot
					{ id = 119072, }, -- гнев небес
					{ id = 26573, }, -- освящение
					{ id = 31850, }, -- ревностный защитник
					{ id = 31935, }, -- щит мстителя
					{ id = 53600, }, -- щит праведника
					{ id = 132403, }, -- щит праведника
					{ id = 114637, }, -- бастион славы
					{ id = 98057, }, -- великий воин света
				},
				[3] = { -- retri
					{ id = 84963, }, -- дознание
					{ id = 53385, }, -- божественная буря
					{ id = 85256, }, -- вердикт храмовника
					{ id = 121783, }, -- освобождение
					{ id = 20164, }, -- печать справедливости
					{ id = 20170, }, -- печать справедливости
					{ id = 879, }, -- экзорцизм
					{ id = 96172, }, -- искусность
					{ id = 59578, }, -- искусство войны
					{ id = 81326, }, -- уязвимость
					{ id = 86698, }, -- дефки
					{ id = 86700, }, -- дефки
					{ id = 86704, }, -- дефки
				},
			},
		})
		table.insert(spec_spells, { -- прист 1 disc 2 holy 3 shadow
			class = "PRIEST",
			specs = {
				[1] = { -- disc
					{ id = 47537, }, -- вознесение??????
					{ id = 62618, }, -- слово силы: барьер
					{ id = 33206, }, -- подавление боли
					{ id = 59889, }, -- лишнее время
					{ id = 47753, }, -- божественное покровительство
					{ id = 47750, }, -- исповедь
					{ id = 47666, }, -- исповедь
					{ id = 89485, }, -- внутреннее сосредоточение
					{ id = 81661, }, -- приверженность
					{ id = 81751, }, -- искупление вины
					{ id = 94472, }, -- искупление вины
					{ id = 77613, }, -- милость
					{ id = 81700, }, -- архангел
					{ id = 109964, }, -- щит души
				},
				[2] = { -- holy 
					{ id = 47788, }, -- оберегающий дух
					{ id = 34861, }, -- круг исцеления
					{ id = 88625, }, -- слово света воздояние
					{ id = 63735, }, -- прозорливость
					{ id = 724, }, -- колодец света
					{ id = 81209, }, -- чакра: воздаяние
					{ id = 81208, }, -- чакра: безмятежность
					{ id = 81206, }, -- чакра: святилище
					{ id = 77489, }, -- отблеск света
					{ id = 88685, }, -- слово света святилище
					{ id = 88686, }, -- святилище тики
					{ id = 88684, }, -- слово света: безмятежность
					{ id = 63544, }, -- мгновенное обновление
				},
				[3] = { -- shadow
					{ id = 15473, }, -- облик тьмы
					{ id = 15407, }, -- пытка разума
					{ id = 15487, }, -- безмолвие
					{ id = 80902, }, -- взрыв разума
					{ id = 73510, }, -- пронзание разума
					{ id = 34914, }, -- прикосновение вампира
					{ id = 34919, }, -- прикосновение вампира
					{ id = 124465, }, -- прикосновение вампира
					{ id = 47585, }, -- слияние с тьмой
					{ id = 2944, }, -- всепожирающая чума
					{ id = 127626, }, -- всепожирающая чума
					{ id = 124467, }, -- всепожирающая чума
					{ id = 64044, }, -- глубинный ужас
					{ id = 15286, }, -- объятья вампира
					{ id = 15290, }, -- объятья вампира
					{ id = 87426, }, -- сумеречный призрак
				},
			},
		})
		table.insert(spec_spells, { -- варлок  1 афли 2 демон 3 дестро -- не полностью демонолог
			class = "WARLOCK",
			specs = {
				[1] = {
					{id = 30108,}, -- нестабильное колдоство
					{id = 48181,}, -- Блуждающий дух
					{id = 980,}, -- агония
					{id = 103103,}, -- гибельная хватка
					{id = 74434,}, -- горящая душа
					{id = 114790,}, -- семя порчи под горящей душой
					{id = 27243,}, -- семя порчи
					{id = 27285,}, -- семя порчи
					{id = 119678,}, -- Обмен душ
					{id = 86121,}, -- Обмен душ
					{id = 1120,}, -- похищение дущи
					{id = 18223,}, -- проклятье изнеможения
					{id = 113860,}, -- Черная душа:страдание
					{id = 60947,}, -- ночной кошмар
				},
				[2] = {
					{id = 114925,}, -- демонический зов
					{id = 1949,}, -- адское пламя
					{id = 103958,}, -- метаморфоза
					{id = 109151,}, -- демонический прыжок
					{id = 6353,}, -- ожог души
					{id = 104027,}, -- ожог души
					{id = 104317,}, -- бес
					{id = 105174,}, -- рука гулдана
					{id = 47960,}, -- пламя тьмы?
					{id = 122355,}, -- огненые недра
					{id = 603,}, -- рок
					{id = 103988,}, -- ближний бой
					{id = 124916,}, -- волна хаоса
					{id = 103988,}, -- фигня какая-то
					{id = 30146,}, -- призыв стража скверны
					{id = 113861,}, -- черная душа знание
				},
				[3] = {
					{id = 348,}, -- жертвенный огонь
					{id = 108683,}, -- огонь и сера
					{id = 17877,}, -- ожог тьмы
					{id = 120451,}, -- пламя зорота
					{id = 17962,}, -- поджигание
					{id = 116858,}, -- стрела хаоса
					{id = 114635,}, -- углеотвод
					{id = 113858,}, -- черная душа разрушение
					{id = 80240,}, -- хаос
					{id = 117828,}, -- обратный поток
				},
			},
		})
		table.insert(spec_spells, { -- хантер 1 повелитель зверей 2 стрельба 3 выживание
			class = "HUNTER",
			specs = {
				[1] = {
					{id = 34471,}, -- зверь внутри
					{id = 19574,}, -- звериный гнев
					{id = 34026,}, -- взять
					{id = 82692,}, -- сконцентрированный огонь
					{id = 19577,}, -- устрашение
					{id = 83468,}, -- сконцентрированный огонь прок
					{id = 53398,}, -- окрыление
					{id = 53257,}, -- бросок кобры
				},
				[2] = {
					{id = 53209,}, -- Выстрел химеры
					{id = 53353,}, -- выстрел химеры
					{id = 76663,}, -- шальная стрела
					{id = 19434,}, -- прицельный встрел
					{id = 63468,}, -- пронзающие стрелы
					{id = 54227,}, -- быстрая концентрация
					{id = 35101,}, -- контузящий залп
					{id = 82926,}, -- огонь
					{id = 82925,}, -- готовься целься пли
					{id = 53220,}, -- устойчивая концентрация
				},
				[3] = {
					{id = 53301,}, -- разрывной выстрел
					{id = 3674,}, -- Черная стрела
					{id = 83077,}, -- смертельный укус змеи
					{id = 118974,}, -- змеиный яд
					{id = 56453,}, -- на изготовку
					{id = 64803,}, -- западня
				},
			},
		})
		table.insert(spec_spells, { -- шаман 1 elem 2 ench 3 restor 
			class = "SHAMAN",
			specs = {
				[1] = {
					{id = 51490,}, -- гром и молния
					{id = 61882,}, -- землетрясение
					{id = 77762,}, -- волна лавы???
					{id = 88765,}, -- громовые раскаты
					{id = 51470,}, -- клятва стихий
					-- {id = ,}, -- сверкание?
					{id = 16246,}, -- ясность мысли   
					{id = 77451,}, -- прок искусности 
					{id = 45297,}, -- прок искусности
					{id = 45284,}, -- прок искусности
				},
				[2] = {
					{id = 60103,}, -- вскипание лавы
					{id = 53817,}, -- оружие водоворота
					{id = 63375,}, -- изначальная мудрость
					{id = 51533,}, -- дух дикого волка
					{id = 1535,}, -- кольцо огня
					{id = 58875,}, -- поступь духа
					{id = 30823,}, -- ярость шамана
					{id = 30808,}, -- высвобожденная ярость
					{id = 77661,}, -- жгучее пламя
					{id = 26364,}, -- статический шок???
					{id = 16278,}, -- шквал       
					{id = 17364,}, -- удар бури
					{id = 32175,}, -- удар бури
					{id = 32176,}, -- удар бури
				},
				[3] = {
					{id = 61295,}, -- быстрина
					{id = 105284,}, -- стойкость предков
					{id = 77472,}, -- великая волна исцеления
					{id = 331,}, -- волна исцеления
					{id = 77130,}, -- Очищение духа???
					{id = 974,}, -- щит земли
					{id = 53390,}, -- приливные волны
					{id = 52752,}, -- пробуждение предков
					{id = 101033,}, -- упоение
					{id = 16190,}, -- тотем прилива маны
					{id = 98008,}, -- тотем духовой связи  --]]
				},
			},
		})
		table.insert(spec_spells, { -- друид 1 balance 2 cat 3 bear 4 resto 
			class = "DRUID",
			specs = {
				[1] = {
					{id = 16886,}, -- Милость природы
					{id = 81070,}, -- затмение
					{id = 112071,}, -- парад планет
					{id = 81283,}, -- микоз
					{id = 88751,}, -- дикий гриб взрыв
					{id = 89265,}, -- энергия затмения
					{id = 24858,}, -- облик лунного совуха
					{id = 24907,}, -- облик лунного совуха
					{id = 48518,}, -- лунное затмение
					{id = 127663,}, -- астральное соединение
					{id = 48517,}, -- солнечное затмение
					{id = 2912,}, -- звездный огонь
					{id = 78674,}, -- звездный поток
					{id = 48505,}, -- звездопад
					{id = 50288,}, -- звездопад
					{id = 81192,}, -- лунный поток
					{id = 93402,}, -- солнечный огонь
					{id = 93400,}, -- падающие звезды
					{id = 78675,}, -- столп солнечного света
				},
				[2] = {
					{id = 5221,}, -- полоснуть
					{id = 52610,}, -- дикий рев
					{id = 5217,}, -- тигриное неистоство
					{id = 69369,}, -- стремительность хищника
				},
				[3] = {
					{id = 132402,}, -- Дикая защита
					{id = 62606,}, -- Дикая защита
					{id = 5229,}, -- иступление
					{id = 102795,}, -- Медвежьи объятья
				},
				[4] = {
					{id = 48438,}, -- буйный рост
					{id = 8936,}, -- восстановление
					{id = 100977,}, -- гармония
					{id = 48504,}, -- семя жизни
					{id = 81269,}, -- быстрое восстановление
					{id = 102791,}, -- дикий гриб лечение
					{id = 102342,}, -- Железная кора
					{id = 33763,}, -- жизнецвет
					{id = 50464,}, -- покровительство природы
					{id = 88423,}, -- природный целитель
				},
			},
		})
		table.insert(spec_spells, { -- маг 1 arcan 2 fire 3 frost
			class = "MAGE",
			specs = {
				[1] = {
					{id = 30451,}, -- чародейская вспышка
					{id = 36032,}, -- чародейский заряд
					{id = 79683,}, -- чародейские стрелы
					{id = 7268,}, -- чародейские стрелы
					{id = 44425,}, -- чародейский обстрел
					{id = 31589,}, -- замедление
					{id = 12042,}, -- мощь тайной магии
				},
				[2] = {
					{id = 11129,}, -- возгорание
					{id = 118271,}, -- возгорание
					{id = 31661,}, -- дыхание дракона
					{id = 11366,}, -- огненая глыба
					{id = 12654,}, -- воспламенение
					{id = 133,}, -- огненый шар
					{id = 108853,}, -- пламенный взрыв
					{id = 48107,}, -- разогрев
				},
				[3] = {
					{id = 12472,}, -- стылая кровь
					{id = 116,}, -- леденая стрела
					{id = 84714,}, -- леденая сфера
					{id = 44544,}, -- ледяные пальцы
					{id = 31687,}, -- пет
					{id = 57761,}, -- заморозка мозгов
				},
			},
		})
		table.insert(spec_spells, { -- рога  1 мути 2 комбат 3 субт
			class = "ROGUE",
			specs = {
				[1] = {
					{id = 93068,}, -- Мастер ядоварения
					{id = 79140,}, -- Вендетта
					{id = 32645,}, -- отравление
					{id = 27576,}, -- Расправа
					{id = 1329,}, -- Расправа
					{id = 5374,}, -- Расправа
					{id = 111240,}, -- Устранение
					{id = 121153,}, -- Слепая зона
				},
				[2] = {
					{id = 57841,}, -- Череда убийств
					{id = 57842,}, -- Череда убийств
					{id = 51690,}, -- Череда убийств
					{id = 84745,}, -- Поверхностное понимание
					{id = 84746,}, -- Умеренное понимание
					{id = 84747,}, -- Глубокое понимание
					{id = 13877,}, -- Шквал клинков
					{id = 86392,}, -- Искусность Правой, левой
					{id = 84617,}, -- Пробивающий удар
					{id = 35546,}, -- Боевой потенциал
					{id = 13750,}, -- Выброс адреналина
				},
				[3] = {
					{id = 91021,}, -- Поиск слабости?
					{id = 51713,}, -- Танец теней
					{id = 14183,}, -- Умысел
					{id = 16511,}, -- Кровоизлияние
					{id = 89775,}, -- Кровоизлияние
					{id = 53,}, -- Удар в спину
				},
			},
		})
		table.insert(spec_spells, { -- дк 1 blood 2 frost 3 unholy
			class = "DEATHKNIGHT",
			specs = {
				[1] = {
					{id = 55050,}, -- удар в сердце
					{id = 81256,}, -- танцующее руническое оружие
					{id = 49028,}, -- танцующее руническое оружие
					{id = 48982,}, -- захват рун
					{id = 49222,}, -- костяной щит
					{id = 55233,}, -- кровь вампира
					{id = 56222,}, -- темная власть
					{id = 50421,}, -- запах крови
					{id = 77535,}, -- щит крови
					{id = 50452,}, -- кровавы паразит
				},
				[2] = {
					{id = 49184,}, -- воющий ветер
					{id = 49143,}, -- ледяной удар
					{id = 51124,}, -- машина для убийств
					{id = 59052,}, -- морозная дымка
					{id = 51271,}, -- ледяной столп
					{id = 49020,}, -- уничтожение
				},
				[3] = {
					{id = 55090,}, -- удар плети
					{id = 49206,}, -- призыв горгули +
					{id = 81340,}, -- неумолимый рок
					{id = 49016,}, -- нечестивое бешенство
					{id = 85948,}, -- удар разложения
					{id = 63560,}, -- темное превращение
					{id = 91342,}, -- вливание тьмы
				},
			},
		})
		table.insert(spec_spells, { -- воин 1 arms, 2 fury 3 prot
			class = "WARRIOR",
			specs = {
				[1] = {
					{id = 125831,}, -- Вкус крови
					{id = 12328,}, -- Размащистые удары
					{id = 12294,}, -- Смертельный удар
					{id = 52437,}, -- Внезапная смерть
					{id = 1464,}, -- Мощный удар
					{id = 7384,}, -- Превосходство
					{id = 76858,}, -- Дополнительный выпад
				},
				[2] = {
					{id = 85739,}, -- Кровавый фарш
					{id = 46916,}, -- Прилив крови
					{id = 23881,}, -- кровожадность
					{id = 12968,}, -- Шквал
					{id = 100130,}, -- зверский удар
					{id = 117313,}, -- кровожадное исцеление
					{id = 96103,}, -- Яростный выпад
					{id = 131116,}, -- Яростный выпад
					{id = 85384,}, -- Яростный выпад
					{id = 85288,}, -- Яростный выпад
				},
				[3] = {
					{id = 23922,}, -- Мощный удар щитом
					{id = 2565,}, -- блок щитом
					{id = 132404,}, -- блок щитом
					{id = 1160,}, -- деморализующий крик
					{id = 122510,}, -- ультиматум
					{id = 112048,}, -- непроницаемый щит
					{id = 12975,}, -- ни шагу назад
					{id = 20243,}, -- Сокрушение
					{id = 50227,}, -- Щит и меч
				},
			},
		})
		table.insert(spec_spells, { -- монах 1 хмелевар (танк) 2 Ткач туманов (лекарь) 3 танцующий с ветром (мили)
			class = "MONK",
			specs = {
				[1] = {
					{id = 115069,}, -- стойка быка
					{id = 115295,}, -- зашита
					{id = 128939,}, -- отвар неуловимости
					{id = 115308,}, -- отвар неуловимости
					{id = 115213,}, -- отведение ударов
					{id = 115181,}, -- пламенное дыхание
					{id = 115315,}, -- статуя быка
					{id = 124506,}, -- дар быка
					{id = 122057,}, -- столкновение
					{id = 121253,}, -- удар кружкой
					{id = 115180,}, -- хмельная дымка
					{id = 116330,}, -- хмельная дымка
					{id = 118636,}, -- мощная защита
				},
				[2] = {
					{id = 115070,}, -- стойка мудрой змеи
					{id = 116694,}, -- Благотворный туман
					{id = 116695,}, -- Благотворный туман
					{id = 115310,}, -- Восстановление сил
					{id = 116680,}, -- Громовой чай
					{id = 115151,}, -- Заживляющий туман
					{id = 119611,}, -- Заживляющий туман
					{id = 119607,}, -- Заживляющий туман
					{id = 116670,}, -- Духовный подъем
					{id = 116849,}, -- Исцеляющий кокон
					{id = 132120,}, -- окутывающий туман
					{id = 124682,}, -- окутывающий туман
					{id = 115867,}, -- маначай
					{id = 115294,}, -- маначай
					{id = 115175,}, -- успокаювающий туман
					{id = 125953,}, -- успокаювающий туман
					{id = 116335,}, -- успокаювающий туман
					{id = 117895,}, -- величие статуя
					{id = 126890,}, -- величие
				},
				[3] = {
					{id = 115288,}, -- будоражащий отвар
					{id = 122470,}, -- закон кармы
					{id = 116781,}, -- наследие белого тигра
					{id = 117418,}, -- неистовые кулаки
					{id = 113656,}, -- неистовые кулаки
					{id = 120086,}, -- неистовые кулаки
					{id = 115073,}, -- огненый цветок
					{id = 116740,}, -- отвар тигриной силы
					{id = 125195,}, -- отвар тигриной силы
					{id = 101545,}, -- удар летящего змея
					{id = 130320,}, -- удар восходящего солнца
					{id = 128531,}, -- дот после нокаутирующего удара
					{id = 116768,}, -- прок нокаута
					{id = 118864,}, -- лапа тигра прок
				},
			},
		})
	end
end

function HCoold:MakeSpellList() -- in future - making self.spells that contains spells, that will be tracking by system by user configuration
	self.spells = {}
	for _,i in next, spells do
		local out = tostring(i.spellID)
		for _,j in next, i.specs do
			out = string.format("%s.%d",out,j)
		end
		if self.db.profile.trackSpells[out] == nil then self.db.profile.trackSpells[out] = true end
		if self.db.profile.trackSpells[out] then 
			table.insert(self.spells,i) 
		end
	end
end

function HCoold:GetSpecBySpell(spellID) -- return spec of class if it used this spell (check if spell is spec uniq)
	for _,i in next, spec_spells do
		for spec,j in next, i.specs do
			for _,p in next, j do
				if p.id == spellID then return spec end
			end
		end
	end
	return 0
end

function HCoold:GenerateSpellList()
	local out = {}
	local order = 1
	local t_ = {}
	local out2 = {}
	for _, i in next, spells do
		local t = tostring(i.type)
		if not out[t] then -- create group if it's not exists
			out[t] = {
				type = "group",
				cmdHidden = true,
				name = L["type"..t],
				desc = L["desc type"..t],
				order = i.type+30,
				args = {},
			}
			out2[t] = {}
			t_[t] = true
		end
		do -- spell add
			local spname = select(1, GetSpellInfo(i.spellID)) or L["No spell found"]
			local splink = select(1, GetSpellLink(i.spellID))
			local specs = ""
			local tmp = ""
			for _, j in next, i.specs do 
				specs = string.format("%s%s%s",specs,tmp,j)
				tmp = ", "
			end
			local desc = function(self)
				GameTooltip:ClearLines()
				if splink then
					GameTooltip:SetHyperlink(splink)
				end
				GameTooltip:AppendText("\n")
				GameTooltip:AppendText(string.format(L["class %s specs %s"],L[i.class],L[i.class .. specs]))
				GameTooltip:AppendText("\n")
				return nil
			end
			local tt = tostring(i.spellID)
			for _,j in next, i.specs do
				tt = string.format("%s.%d",tt,j)
			end
			local s = {
				type = "toggle",
				name = spname,
				desc = desc,
				descStyle = "Toggle",
				set = function(tmp,key)
					self.db.profile.trackSpells[tt] = key
				end,
				get = function() 
					return self.db.profile.trackSpells[tt]
				end,
				--order = order,
			}
			--out[t].args[tostring(order)] = s
			--order = order+1
			if not out2[t][i.class] then out2[t][i.class] = {} end
			table.insert(out2[t][i.class],s)
		end
	end
	for t, ss in next, out2 do
		out[t].args.turnoff = {
			type = "execute",
			name = L["turn all off"],
			desc = L["desc turn all off"],
			func = function() for _, i in next, out[t].args do if i.type == "toggle" then i.set(nil,false) end end end,
			order = 1,
		}
		out[t].args.turnon = {
			type = "execute",
			name = L["turn all on"],
			desc = L["desc turn all on"],
			func = function() for _, i in next, out[t].args do if i.type == "toggle" then i.set(nil,true) end end end,
			order = 2,
		}
		local count = 5
		for class, tt in next, ss do
			out[t].args[tostring(count)] = {
				type = "header",
				name = L[class],
				order = count,
			}
			count = count + 1
			for _,i in next, tt do
				i.order = count
				out[t].args[tostring(count)] = i
				count = count + 1
			end
		end
	end
	
	local sm = {}
	for i,j in next, self.sort_methods do sm[i] = j.desc end
	for i in next, t_ do
		local k_ = (tonumber(i) or 1)
		local k = k_ + 5
		-- self:Printf("%s",k)
		--self:Printf("%s %s %s","width" .. i,k,self.db.profile.types[k].w)
		out["header" .. i] = {
			type = "header",
			cmdHidden = true,
			name = L["header" .. i],
			order = k * 10 + 1
		}
		out["width" .. i] = {
			type = "input",
			cmdHidden = true,
			name = L["type width"..i],
			desc = L["desc type width"..i],
			order = k * 10 + 2,
			width = "half",
			set = function(a1,val)
				val = tonumber(val) or 100
				self.db.profile.types[k_].w = val
				if self.types[k_] then self.types[k_]:SetWidth(val) end
			end,
			get = function()
				return tostring(self.db.profile.types[k_].w)
			end,
		}
		
		out["sort" .. i] = {
			type = "select",
			-- width = "half",
			name = L["sort method" .. i],
			desc = L["desc sort method" .. i],
			order = k * 10 + 3,
			cmdHidden = true,
			values = sm,
			get = function() 
				return self.db.profile.types[k_].sm 
			end,
			set = function(tmp, val) 
				self.db.profile.types[k_].sm = val
				if self.types[k_] then self.types[k_]:SetSortMethod(val) end
			end,
		}

		out["enable" .. i] = {
			type = "toggle",
			name = L["enable" .. i],
			desc = L["desc enable" .. i],
			order = k*10 + 4,
			cmdHidden = true,
			set = function(t, val)
				self.db.profile.types[k_].enable = val
				if self.types[k_] then self.types[k_]:Enable(val) end
			end,
			get = function() return self.db.profile.types[k_].enable end,
		}
	end
	
	return out
end

do -- expert configuration of spells
	function HCoold:RunPersonalSpellConfig()
		local AceGUI = LibStub("AceGUI-3.0")
		local pspells = self.db.faction.PlayersSpells
		
		local f = AceGUI:Create("Frame")
		local s = AceGUI:Create("ScrollFrame")
		local AddLine = nil
		local ann_res = false
		do -- frame creation
			f:SetLayout("Fill")
			f.state = true
			f:SetCallback("OnClose",function(widget) 
				f.state = false
				AceGUI:Release(widget) 
		
				if ann_res then
					StaticPopupDialogs["HCooldRedoLayout"]= {
						text = string.format(L["Don't forget to redraw layout to aply settings."]), 
						button1 = ACCEPT,
						timeout = 30, 
						whileDead = 0, 
						hideOnEscape = 1, 
					}
					StaticPopup_Show("HCooldRedoLayout")
				end
				
				HCoold:RunConfig()
			end)
			f:SetTitle(L["Manual spell settings"])

			s:SetLayout("List") -- probably?
			f:AddChild(s)
		end
		
		do -- create tools to create spell info
			local types = {}
			for _, i in next, spells do
				if not types[i.type] then
					types[i.type] = L["type" .. i.type]
				end
			end
			--table.sort(types)
		
			local sg1 = AceGUI:Create("InlineGroup")
			do -- sg1
				sg1:SetTitle(L["Add new spell options for current player."])
				sg1:SetFullWidth(true)
				sg1:SetLayout("Flow")
				sg1:SetAutoAdjustHeight(true)
				s:AddChild(sg1)
			end
			
			local dd1 = AceGUI:Create("Dropdown") -- type of spell
			local dd2 = AceGUI:Create("Dropdown") -- spell list in this category
			local inp1 = AceGUI:Create("EditBox") -- player name
			local inp2 = AceGUI:Create("EditBox") -- CD in sec
			local inp3 = AceGUI:Create("EditBox") -- id of spell
			local inp4 = AceGUI:Create("EditBox") -- casting time
			local inp5 = AceGUI:Create("EditBox") -- trigger event
			local dd3 = AceGUI:Create("Dropdown") -- quality of spell
			local dd4 = AceGUI:Create("Dropdown") -- spec of player to track spell
			local doit = AceGUI:Create("Button") -- button to add spell
			local values = {}
			local splist = {}
			local function onValueChanged()
				inp2:SetText()
				inp4:SetText()
				inp5:SetText()
				inp5:Fire("OnEnterPressed")
			end
			do --dd1
				sg1:AddChild(dd1)
				dd1:SetList(types)
				dd1:SetWidth(HCoold.config.dropdownwidth)
				dd1:SetCallback("OnValueChanged",function(_,_,key)
					splist = {}
					values = {}
					key = key or 8
					dd2:SetValue()
					inp3:SetText()
					for _, i in next, spells do
						if i.type == key then
							values[i.spellID] = select(1,GetSpellInfo(i.spellID))
							splist[i.spellID] = i
						end
					end
					dd2:SetList(values)
					onValueChanged()
				end)
				dd1:SetValue(8)
				dd1:Fire("OnValueChanged")
			end
			do --inp3
				inp3:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp3)
				inp3:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp3.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter id of spell"])
					GameTooltip:Show()
				end)
				inp3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp3:SetCallback("OnEnterPressed",onValueChanged)
			end
			do --dd2 --------- дописать изъятие кд и прочих вещей из БД
				dd2:SetWidth(HCoold.config.dropdownwidth)
				sg1:AddChild(dd2)
				dd2:SetCallback("OnValueChanged",function(_,_,key)
					onValueChanged()
					inp3:SetText(key)
					inp4:SetText(splist[key].cast_time or 0)
					inp2:SetText(splist[key].CD or 0)
					inp5:SetText(splist[key].succ or "SPELL_CAST_SUCCESS")
				end)
			end
			do --inp1
				inp1:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp1)
				inp1:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp1.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter player name"])
					GameTooltip:Show()
				end)
				inp1:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			do --inp2
				inp2:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp2)
				inp2:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp2.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter CD of spell in sec"])
					GameTooltip:Show()
				end)
				inp2:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp2:SetCallback("OnEnterPressed",function() inp2:SetText(math.max(0,math.ceil(tonumber(inp2:GetText()) or 0))) end)
			end
			do --inp4
				inp4:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp4)
				inp4:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp4.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter casting time of spell"])
					GameTooltip:Show()
				end)
				inp4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp4:SetCallback("OnEnterPressed",function()
					local v = inp4:GetText()
					v = math.max(0,tonumber(v) or 0)
					inp4:SetText(v)
				end)
			end
			do --dd3
				sg1:AddChild(dd3)
				dd3:SetWidth(HCoold.config.dropdownwidth)
				dd3:SetList({1, 2, 3})
				dd3:SetValue(1)
				dd3:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(dd3.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter quality of spell"])
					GameTooltip:Show()
				end)
				dd3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			local spec_list = {"0","1","2","3","1,2","1,3","2,3"}
			do --dd4
				sg1:AddChild(dd4)
				dd4:SetList(spec_list)
				dd4:SetWidth(HCoold.config.dropdownwidth)
				dd4:SetCallback("OnValueChanged",function(_,_,key)
				end)
				dd4:SetCallback("OnEnter",function(self)
					GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
					GameTooltip:AddLine(L["Spec list by class"])
					GameTooltip:Show()
				end)
				dd4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			do --inp5
				inp5:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp5)
				inp5:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp5.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter trigger event from combat log"])
					GameTooltip:Show()
				end)
				inp5:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp5:SetCallback("OnEnterPressed",function() if inp5:GetText() == "" then inp5:SetText("SPELL_CAST_SUCCESS") end end)
				inp5:Fire("OnEnterPressed")
			end
			do --doit 
				doit:SetWidth(HCoold.config.addbuttonwidth)
				doit:SetText(L["Add spell"])
				sg1:AddChild(doit)
				doit:SetCallback("OnEnter",function(self)
					local splink = GetSpellLink(tonumber(inp3:GetText()) or 0)
					if not splink then return end
					GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
					GameTooltip:SetHyperlink(splink)
					GameTooltip:Show()
				end)
				doit:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			doit:SetCallback("OnClick",function()
				inp2:Fire("OnEnterPressed")
				inp1:Fire("OnEnterPressed")
				inp4:Fire("OnEnterPressed")
				inp5:Fire("OnEnterPressed")
				local spid, name, cd, casttime, sptype, trigger, quality = tonumber(inp3:GetText()), inp1:GetText(), tonumber(inp2:GetText()), tonumber(inp4:GetText()), dd1:GetValue(),inp5:GetText(),dd3:GetValue()
				if cd > 0 and string.len(name) > 0 and spid > 0 and GetSpellInfo(spid) ~= nil then
					local spec_spec = {
						["0"] = { 0 },
						["1"] = { 1 },
						["2"] = { 2 },
						["3"] = { 3 },
						["1,2"] = { 1, 2 },
						["1,3"] = { 1, 3 },
						["2,3"] = { 2, 3 },
					}
					local i = {
						spellID = spid,
						succ = trigger,
						player = name,
						CD = cd,
						type = sptype,
						cast_time = casttime,
						specs = spec_spec[spec_list[dd4:GetValue() or 1]],
						quality = quality,
					}
					table.insert(pspells,i)
					ann_res = true
					AddLine(i)
					f:SetStatusText(L["Cooldown successfully added!"])
				else
					f:SetStatusText(L["You should enter spell id, player name and cooldown of spell."])
				end
			end)
		end
		
		do -- add List of spells
			function DeleteFromMemory(i)
				for k, j in next, pspells do
					if j == i then 
						table.remove(pspells,k)
						f:SetStatusText(L["Cooldown successfulle deleted!"])
					end
				end
			end
			
			AddLine = function(i)
				local sg2 = AceGUI:Create("InlineGroup")
				sg2:SetLayout("Flow")
				sg2:SetFullWidth(true)
				s:AddChild(sg2)
				
				local spname,_, spicon = GetSpellInfo(i.spellID)
				local splink = GetSpellLink(i.spellID)
				
				local label = AceGUI:Create("InteractiveLabel")
				label:SetImageSize(21,21)
				label:SetFullWidth(true)
				label:SetImage(spicon)
				local specs = ""
				local first = nil
				if i.specs then for _, k in next, i.specs do 
					if not first then first = ""
					else first = ", " end
					specs = string.format("%s%s%d",specs,first,k)
				end end
				label:SetText(string.format(L["Spell %s(id=%d, type=%s, quality=%d, specs=%s) for player %s has CD %d sec cast time %.1f and trigger from %s."],splink,i.spellID,L["type" .. i.type],i.quality,specs,i.player,i.CD,i.cast_time,i.succ))
				label:SetCallback("OnEnter",function(self)
					GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
					GameTooltip:SetHyperlink(splink)
					GameTooltip:Show()
				end)
				label:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				sg2:AddChild(label)
				
				local cb = AceGUI:Create("CheckBox")
				sg2:AddChild(cb)
				cb:SetValue(self.db.profile.trackManualSpells[self:ManualSpellIndex(i)])
				cb:SetWidth(HCoold.config.checkboxwidth)
				cb:SetLabel(L["Track spell"])
				cb:SetCallback("OnValueChanged",function() 
					self.db.profile.trackManualSpells[self:ManualSpellIndex(i)] = cb:GetValue() 
					ann_res = true
				end)
				
				sg2:SetTitle(string.format(L["Configuration for %s spell"],spname))
				local k = AceGUI:Create("Button")
				k:SetWidth(HCoold.config.deletebuttonwidth)
				k:SetText(L["Delete"])
				sg2:AddChild(k)
				k:SetCallback("OnClick",function()
					StaticPopupDialogs["HCooldAcceptDeleteSpell"]= {
						text = string.format(L["You realy want to delete spell %s?"],spname), 
						button1 = ACCEPT,
						button2 = CANCEL,
						timeout = 30, 
						whileDead = 0, 
						hideOnEscape = 1, 
						OnAccept = function() 
							k:SetDisabled(true)
							k:SetText(L["Deleted"])
							DeleteFromMemory(i)
							ann_res = true
						end,
					}
					StaticPopup_Show("HCooldAcceptDeleteSpell")
				end)
			end
			
			for _, i in next, pspells do AddLine(i) end
		end
		
		return f
	end
end






















